#include <NDS/NDS.h>
#include <NDS/ARM9/rand.h>
#include <NDS/ARM9/console.h> //basic print funcionality

#define PT1_CR1    (*(vuint16*)0x040001A0)
#define PT1_DATA   (*(vuint16*)0x040001A2)
#define PT1_WaitBusy()   while (PT1_CR1 & /*BUSY*/0x80); 

#define MAX 50  // 10̔{
int ave_buf[MAX];

u8 SPI(u8 d)
{
	u8 res;
	PT1_DATA = d;
	PT1_WaitBusy();
	res=PT1_DATA;
	return res;
}

int Ondo()
{
	u16 d1,d2,d;
	int data;
	PT1_CR1 = /*E*/0x8000 | /*SEL*/0x2000 | /*MODE*/0x40 | 3;  // 524kHz
	d1=SPI(0x00);
	d2=SPI(0x00);
	
	PT1_CR1 = 3;
	
	d = (d1*256 + d2)>>3;
	
	if (d<0x1000) {
		data=d;
	} else {
		data=-(0x2000-d);
	}
	
	return data;
}



int main()
{	
	u16 key_st,prev_key;
	int i,wt,v,t,total,d1,d2;
	u8 c;
	prev_key=0;
	powerON(POWER_LCD_TOP | POWER_LCD_BOTTOM | POWER_2D | POWER_2D_SUB |
			POWER_3D_CORE | POWER_MATRIX | POWER_SWAP_LCDS);
	videoSetMode(MODE_0_2D | DISPLAY_BG0_ACTIVE | ENABLE_3D);
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE); //sub bg 0 will be used to print text
	vramSetBankC(VRAM_C_SUB_BG); 
	SUB_BG0_CR = BG_MAP_BASE(31);
	BG_PALETTE_SUB[255] = RGB15(31,31,31);//by default font will be rendered with color 255
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);
	
	WAIT_CR &= ~0x0880;	// DS Card access ARM9:bit11=0   GBA Cart access ARM9:bit7=0
	
	
	v= Ondo();
	for (i=0;i<MAX;i++) { ave_buf[i]=v; }
	
	consolePrintSet(0,1);
	consolePrintf("<<< LM74 TEST >>>\n");
	
	while (1) {
		
		v= Ondo();
		
		for (i=0;i<MAX-1;i++) { ave_buf[i]=ave_buf[i+1]; }
		ave_buf[MAX-1]=v;
		
		total=0;
		for (i=0;i<MAX;i++) {
			total += ave_buf[i];
		}
		
		v = total/(MAX/10);
		
		//consolePrintSet(0,2);
		//consolePrintf("code=%d  \n",v);
		
		
		t = v * 625;
		t = t/1000;
		
		d1= t/100; d2= t%100;
		consolePrintSet(0,4);
		consolePrintf("T=%d.%02d  \n",d1,d2);
		
		
		key_st = KEYS;
		if (key_st != prev_key) {
			//if ( ( !(key_st & KEY_LEFT) )&&( !(key_st & KEY_RIGHT)) &&( !(key_st & KEY_START) ) ) { break; }
		}
		prev_key = key_st;
		for (wt=0;wt<10000;wt++) { ; } //wait
	}
	
	
	return 0;
}//end main 

